/****************************************************************
* Modul:   TA.BA_MMT.HS1301 - Multimedia Technik (MMT)
* Subject: Processing - Uebung 7 - Bilder verknüpfen
* Author:  Felix Rohrer
* Desc:    Pixel addieren, subtrahieren, multiplizieren
****************************************************************/

PImage img1;
PImage img2;
PImage res;
int mode = 1; // 0 = multiplikation, 1 = addition, 2 = subtraktion

// ----- setup() ------------------------------------------------
void setup() {
  img1 = loadImage("muster04.jpg");
  img2 = loadImage("elise.png");
  
  updateImage();

  size(img1.width, img1.height);
}

// ----- draw() -------------------------------------------------
void draw() {
  background(255, 255, 255);
  
  image(res, 0, 0);
}


void updateImage() {
  color img1Color;
  color img2Color;
  
  res = new PImage(img1.width, img1.height);
  res.loadPixels(); 
  

  for (int yPos = 0; yPos < img1.height; yPos++) {
    for (int xPos = 0; xPos < img1.width; xPos++) {
      img1Color = img1.pixels[yPos * img1.width + xPos];
      img2Color = img2.pixels[yPos * img1.width + xPos];

      res.pixels[yPos * img1.width + xPos] = calcNewColor(img1Color, img2Color);
    }
  }
  res.updatePixels();
  
}

color calcNewColor(color img1, color img2) {
  color res = color(0, 0, 0);
  float r1 = 0, r2 = 0;
  float g1 = 0, g2 = 0;
  float b1 = 0, b2 = 0;
  
  r1 += img1 >> 16 & 0xFF; // red(img1);
  g1 += img1 >> 8 & 0xFF;  // green(img1);
  b1 += img1 & 0xFF;       // blue(img1);
  
  r2 += img2 >> 16 & 0xFF; // red(img2);
  g2 += img2 >> 8 & 0xFF;  // green(img2);
  b2 += img2 & 0xFF;       // blue(img2); 
  
  
  switch (mode) {
    case 1: // 1 = addition
            res = color((r1 + r2) / 2, (g1 + g2) / 2, (b1 + b2) / 2);
            break;
    case 2: // 2 = subtraktion
            res = color((r1 - r2), (g1 - g2) , (b1 - b2) );
            break;
    default: // 0 = multiplikation
            res = color(r1 * r2 / 255, g1 * g2 / 255, b1 * b2 / 255);
  }
  return res;
}

void keyPressed() {
  // Methode
  if (key == '1') {
    mode = 0;
  }
  else if (key == '2') {
    mode = 1;
  }
  else if (key == '3') {
    mode = 2;
  }
  // Vordergrund Bild
  else if (key == 'q') {
    img2 = loadImage("elise.png");
  }
  else if (key == 'w') {
    img2 = loadImage("elise02.png");
  }
  else if (key == 'e') {
    img2 = loadImage("exige.png");
  }
  // Hintergrund
  else if (key == 'a') {
    img1 = loadImage("muster01.jpg");
  }
  else if (key == 's') {
    img1 = loadImage("muster02.jpg");
  }
  else if (key == 'd') {
    img1 = loadImage("muster03.jpg");
  }
  else if (key == 'f') {
    img1 = loadImage("muster04.jpg");
  }
  else if (key == 'g') {
    img1 = loadImage("steine.jpg");
  }
  else if (key == 'h') {
    img1 = loadImage("abstrakt.jpg");
  }
  // Save Image
  else if (key == 'p') {
    save("Ueb07-4.png");
  }
  updateImage();
  redraw();
}

